# -*- coding: utf-8 -*-

from collections import OrderedDict

from kinder.core.dict.models import WorkType


APPLICATION_INDEXES = OrderedDict([
    ('1', u'(1)Общее количество детей, поставленных '
          u'на учет в текущем календарном году'),
    ('1.1', u'(1.1)Общее число заявлений, поданных для постановки '
            u'на учет, в разрезе возрастных категорий %s (на текущую дату)'),
    ('2.1', u'(2.1)Общее количество заявлений поданных с портала,'
            u' в возрасте %s (на текущую дату)'),
    ('3.1', u'(3.1)Общее количество заявлений поданных '
            u'при личном обращении, в возрасте %s (на текущую дату)'),
    ('4', u'(4)Общее количество детей, поставленных на учет '
          u'для получения места в текущем учебном году, '
          u'для детей в возрасте %s (на текущую дату)'),
    ('4.1', u'(4.1)Общее количество детей, поставленных на учет в группы '
            u'для детей с овз для получения места в текущем учебном году '
            u'(компенсирующие группы) детей в возрасте %s (на текущую дату)'),
    ('4.2', u'(4.2)Общее количество детей, поставленных на '
            u'учет в оздоровительные группы в возрасте %s (на текущую дату)'),
    ('5', u'(5)Общее количество детей, поставленных на учет для '
          u'получения места в текущем учебном году в другой ДОО, '
          u'детей в возрасте %s (на текущую дату)'),
    ('6', u'(6)Общее количество заявлений, поданных для постановки '
          u'на учет для зачисления в группы кратковременного '
          u'пребывания детей, для детей в возрасте %s (на текущую дату)'),
])


QUEUE_INDEXES = OrderedDict([
    ('7', u'(7)Численность детей, стоящих на учете '
          u'(отложенный спрос) в возрасте %s '
          u'(на 1 сентября текущего календарного года)'),
    ('7.1', u'(7.1)Численность детей, стоящих на учете '
            u'(отложенный спрос) в возрасте %s (на текущую дату)'),
    ('7.2', u'(7.2)Численность детей, желающих получить '
            u'место в текущем учебном году '
            u'(спрос на текущий учебный год), '
            u'в возрасте %s (на текущую дату)'),
    ('7.3', u'(7.3)Численность детей, желающих получить место в следующем '
            u'учебном году (отложенный спрос на следующий учебный год) '
            u'год в возрасте %s (на текущую дату)'),
    ('7.4', u"(7.4)Численность направленных в ДОО детей, желающих "
            u"получить место в текущем учебном году "
            u"(удовлетворенный спрос на текущий учебный год) "
            u"в возрасте %s (на текущую дату)"),
    ('7.5', u"(7.5)Численность детей, желающих получить место в следующем "
            u"учебном году и ранее (актуальный спрос на следующий учебный "
            u"год) в возрасте %s (на текущую дату)"),
    ('7.6', u"(7.6)Численность детей, желающих получить место в следующем "
            u"учебном году и ранее (актуальный спрос на следующий учебный "
            u"год) в возрасте %s (на первое сентября следующего "
            u"учебного года)"),
    ('7.7', u"(7.7)Численность детей, желающих получить место в следующем "
            u"учебном году и ранее (удовлетворенный спрос на следующий учебный"
            u"год) в возрасте %s (на первое сентября следующего "
            u"учебного года)"),
    ('8', u'(8)Среднее время ожидания места, в возрасте %s '
          u'(на желаемую дату зачисления)'),
    ('8.1', u'(8.1)Среднее время ожидания места для детей без льгот, '
            u'в возрасте %s (на желаемую дату зачисления)'),
    ('8.2', u'(8.2)Среднее время ожидания места для детей, имеющих льготы, '
            u'в возрасте %s (на желаемую дату зачисления)'),
    ('8.3', u'(8.3)Среднее время ожидания места для детей с ОВЗ, '
            u'в возрасте %s (на желаемую дату зачисления)'),
    ('9', u'(9)Общая численность детей в очереди, '
          u'имеющих право на внеочередное или первоочередное зачисление '
          u'возрасте %s (на 1 сентября текущего календарного года)'),
    ('9.1', u'(9.1)Общая численность детей в очереди, имеющих '
            u'право на внеочередное или первоочередное зачисление '
            u'возрасте %s (на текущую дату)'),
    ('10', u'(10)Общая численность детей в очереди, имеющих '
           u'право на внеочередное или первоочередное зачисление '
           u'на основании федеральных льгот'),
    ('10.1', u'(10.1)Общая численность детей в очереди, имеющих право на '
             u'первоочередное зачисление в связи с их инвалидностью '
             u'в возрасте %s (на текущую дату)'),
    ('11', u'(11)Общая численность детей в очереди, имеющих '
           u'право на внеочередное или первоочередное зачисление '
           u'на основании региональных льгот'),
    ('12', u'(12)Общая численность детей с ограниченными возможностями '
           u'здоровья в очереди. в возрасте %s (на текущую дату)'),
    ('12.1', u'(12.1)Численность детей с ограниченными возможностями '
             u'здоровья в очереди (удовлетворенный спрос) '
             u'в возрасте %s (на текущую дату)'),
    ('13', u"(13)Численность детей с ограниченными возможностями "
           u"здоровья в очереди, которые могут обучаться в "
           u"общеразвивающих группах, в возрасте %s (на текущую дату)"),
    ('13.1', u'(13.1)Численность детей с ограниченными возможностями '
             u'здоровья в очереди (частично удовлетворенный спрос) '
             u'в возрасте %s (на текущую дату)'),
    ('14', u"(14)Общая численность детей в очереди, "
           u"нуждающихся в группах оздоровительной направленности, "
           u"в возрасте %s (на текущую дату)"),
    ('15', u'(15)Общая численность детей в очереди, согласных '
           u'получить место в группах по присмотру и уходу '
           u'в возрасте %s (на текущую дату)'),
    ('16', u'(16)Общая численность детей в очереди, желающих получить '
           u'место в группах круглосуточного пребывания детей, '
           u'в возрасте %s (на текущую дату)'),
    ('17', u'(17)Общая численность детей в очереди, желающих получить '
           u'место в группах кратковременного пребывания детей '
           u'в возрасте %s (на текущую дату)'),
    ('17.1', u'(17.1)Общая численность детей в очереди, согласных получить '
             u'место в группах кратковременного пребывания '
             u'детей в возрасте %s (на текущую дату)'),
    ('18', u'(18)Общая численность детей в очереди, '
           u'не обеспеченных местами в ДОО (актуальный спрос) в '
           u'возрасте %s (на 1 сентября текущего календарного года)'),
    ('18.1', u'(18.1)Общая численность детей в очереди, не обеспеченных '
             u'местами в ДОО (актуальный спрос) в '
             u'возрасте %s (на текущую дату)'),
    ('18.2', u'(18.2)Общая численность детей в очереди, '
             u'не обеспеченных местами в ДОО (актуальный спрос), '
             u'в возрасте %s (1 января следующего календарного года)'),
    ('18.3', u'(18.3)Общая численность детей в очереди, обеспеченных '
             u'местами в ДОО (удовлетворенный актуальный спрос), '
             u'в возрасте %s (на текущую дату)'),
    ('18.4', u'(18.4)Численность детей в очереди, не обеспеченных местами в ДОО'
             u'(текущий спрос), в возрасте %s (на текущую дату)'),
    ('18.5', u'(18.5)Общая численность детей в очереди, не обеспеченных '
             u'местами в ДОО (общий спрос), в возрасте %s (на текущую дату)'),
])


ENROLLED_INDEXES = OrderedDict([
    ('19', u'(19)Общая численность детей, зачисленных в ДОО, в возрасте %s '
           u'(на 1 сентября текущего календарного года)'),
    ('19.1', u'(19.1)Общая численность детей, зачисленных в ДОО, '
             u'в возрасте %s (на текущую дату)'),
    ('19.2', u'(19.2)Общая численность детей, зачисленных в ДОО, '
             u'в возрасте %s (1 января следующего календарного года)'),
    ('19.3', u'(19.3)Прогнозируемое увеличение контингента '
             u'воспитанников, в возрасте %s (на текущую дату)'),
    ('20', u'(20)Общая численность детей, желающих перейти в '
           u'данную ДОО, в возрасте %s (на текущую дату)'),
    ('20.1', u'(20.1)Общая численность детей, желающих перейти в '
             u'данную ДОО (удовлетворенный спрос), '
             u'в возрасте %s (на текущую дату)'),
    ('20.2', u'(20.2)Общая численность детей, желающих получить '
             u'место в данную ДОО в группах для детей с ограниченными '
             u'возможностями здоровья, в возрасте %s (на текущую дату)'),
    ('20.3', u'(20.3)Общая численность детей, желающих перейти '
             u'в данную ДОО в текущем учебном году, '
             u'в возрасте %s (на текущую дату)'),
    ('20.4', u'(20.4)Общая численность детей, желающих перейти в '
             u'данную ДОО в более поздние сроки, '
             u'в возрасте %s (на текущую дату)'),
    ('20.5', u'(20.5)Общая численность детей в очереди, желающих получить '
             u'иное место в ДОО (общий спрос из желающих сменить ДОО) '
             u'в возрасте %s (на текущую дату)'),
    ('20.6', u'(20.6)Общая численность детей в очереди, желающих получить '
             u'иное место в ДОО (по причине изменения режима пребывания '
             u'ребенка в группе) в возрасте %s (на текущую дату)'),
    ('20.7', u'(20.7)Общая численность детей в очереди, желающих получить '
             u'иное место в ДОО (по причине изменения направленности группы) '
             u'в возрасте %s (на текущую дату)'),
    ('20.8', u'(20.8)Общая численность детей в очереди, желающих получить '
             u'иное место в ДОО (по причине изменения типа собственности) '
             u'в возрасте %s (на текущую дату)'),
    ('21', u'(21)Общая численность детей, получающих дошкольное '
           u'образование в семейных дошкольных группах, '
           u'в возрасте %s (на текущую дату)'),
    ('22', u'(22)Общая численность детей, зачисленных в группы для детей '
           u'с ограниченными возможностями здоровья, '
           u'в возрасте %s (на текущую дату)'),
    ('22.1', u'(22.1)Общая численность детей, зачисленных в группы для детей '
             u'с нарушением слуха,'
             u'в возрасте %s (на текущую дату)'),
    ('22.1.1', u'(22.1.1)Общая численность детей, зачисленных в группы для детей '
             u'с нарушением слуха(глухие),'
             u'в возрасте %s (на текущую дату)'),
    ('22.1.2', u'(22.1.2)Общая численность детей, зачисленных в группы для детей '
             u'с нарушением слуха(слабослышащие и позднооглохшие),'
             u'в возрасте %s (на текущую дату)'),
    ('22.2', u'(22.2)Общая численность детей, зачисленных в группы для детей '
             u'с нарушением речи, '
             u'в возрасте %s (на текущую дату)'),

    ('22.3', u'(22.3)Общая численность детей, зачисленных в группы для детей '
             u'с нарушением зрения, '
             u'в возрасте %s (на текущую дату)'),

    ('22.3.1', u'(22.3.1)Численность детей с ОВЗ, зачисленных в группы для '
               u'детей с нарушением зрения (слепые)'),

    ('22.3.2', u'(22.3.2)Численность детей с ОВЗ, зачисленных в группы для '
               u'детей с нарушением зрения (слабовидящие)'),

    ('22.4', u'(22.4)Общая численность детей, зачисленных в группы для детей '
             u'с нарушением интеллекта, '
             u'в возрасте %s (на текущую дату)'),

    ('22.5', u'(22.5)Общая численность детей, зачисленных в группы для детей '
             u'с задержкой психического развития, '
             u'в возрасте %s (на текущую дату)'),

    ('22.5.1', u'(22.5.1)Численность детей с ОВЗ, зачисленных в группы для '
               u'детей с задержкой психического развития, '
               u'в возрасте %s (на текущую дату)'),

    ('22.5.2', u'(22.5.2)Численность детей с ОВЗ, зачисленных в группы для '
               u'детей с расстройством аутистического спектра, '
               u'в возрасте %s (на текущую дату)'),

    ('22.6', u'(22.6)Общая численность детей, зачисленных в группы для детей '
             u'с нарушением опорно-двигательного аппарата, '
             u'в возрасте %s (на текущую дату)'),

    ('22.7', u'(22.7)Общая численность детей, зачисленных в группы для детей '
             u'со сложным дефектом, '
             u'в возрасте %s (на текущую дату)'),
    ('22.8', u'(22.8)Общая численность детей, зачисленных в группы для детей '
             u'с иными ограниченными возможностями здоровья, '
             u'в возрасте %s (на текущую дату)'),
    ('22.8.1', u'(22.8.1)Общая численность детей, зачисленных в группы для '
               u'детей с синдромом дефицита внимания и гиперактивности (СДВГ), '
               u'в возрасте %s (на текущую дату)'),
    ('22.8.2', u'(22.8.2)Общая численность детей, зачисленных в группы для '
               u'детей после операции по кохлеарной имплантации, '
               u'в возрасте %s (на текущую дату)'),
    ('23', u'(23)Общая численность детей, зачисленных в группы '
           u'компенсирующей направленности, в возрасте %s (на текущую дату)'),
    ('24', u'(24)Общая численность детей, зачисленных в группы '
           u'оздоровительной направленности, '
           u'в возрасте %s (на текущую дату)'),
    ('25', u'(25)Общая численность детей, зачисленных в группы по '
           u'присмотру и уходу, в возрасте %s (на текущую дату)'),
    ('26', u'(26)Общая численность детей, посещающих группы '
           u'круглосуточного пребывания детей, '
           u'в возрасте %s (на текущую дату)'),
    ('27', u'(27)Общая численность детей, зачисленных в группы '
           u'кратковременного пребывания детей, '
           u'в возрасте %s (на текущую дату)'),
    ('28', u'(28)Общая численность детей, посещающих ДОО в режиме '
           u'кратковременного пребывания, в возрасте %s (на текущую дату)'),
    ('29', u'(29)Прогнозируемое уменьшение контингента'),
    ('29.1', u'(29.1)Прогнозируемое уменьшение контингента воспитанников в '
             u'связи с переходом в другую ДОО в возрасте %s (на текущую дату)'),
    ('29.2', u'(29.2)Фактическое уменьшение контингента воспитанников в текущем учебном году '
             u'в возрасте %s (на дату приказа об отчислении)'),
    ('29.3', u'(29.3)Фактическое уменьшение контингента воспитанников '
             u'в связи с уходом в школу в текущем учебном году '
             u'в возрасте %s (на 1 сентября следующего учебного года)'),
    ('30', u'(30)Численность детей-инвалидов, не имеющих ограниченных '
           u'возможностей здоровья, в возрасте %s (на текущую дату)'),
    ('30.1', u'(30.1)Численность детей-инвалидов, имеющих ограниченные '
             u'возможности здоровья, в возрасте %s (на текущую дату)'),
    ('30.2', u'(30.2)Численность детей, не имеющих инвалидности, '
             u'но имеющих ограниченные возможности здоровья, '
             u'в возрасте %s (на текущую дату)')
])


CAPACITIES_INDEXES = OrderedDict([
    ('31', u'(31)Количество свободных мест на дату сбора '
           u'отчетности в возрастных группах, в возрасте %s'),
    ('31.1', u'(31.1)Количество свободных мест в группах для детей '
             u'с ограниченными возможностями здоровья в возрасте %s'),
    ('31.2', u'(31.2)Количество свободных мест в группах для детей '
             u'компенсирующей направленности в возрасте %s'),
    ('31.3', u'(31.3)Количество свободных мест в группах для детей '
             u'оздоровительной направленности в возрасте %s'),
    ('31.4', u'(31.4)Количество свободных мест в группах кратковременного '
             u'пребывания в государственных '
             u'образовательных организациях в возрасте %s'),
    ('32', u'(32)Численность детей, получивших направления в ДОО '
           u'и зачисленных в ДОО в текущем календарном году,'
           u'в возрасте %s'),
    ('32.1', u'(32.1)Общая численность детей, получивших направления в ДОО,'
             u'в текущем календарном году, в возрасте %s'),
    ('32.2', u'(32.2)Численность детей, получивших направления в ДОО, '
             u'не воспользовавшихся предоставленным местом %s'),
    ('33', u'(33)Численность детей, выбывших из очереди по иным причинам'
           u'в возрасте %s'),
])


def get_all_day_work_types():

    work_types = WorkType.objects.all()
    all_day_types = [WorkType.ALLDAY]
    for work_type in work_types:
        code = work_type.code
        try:
            torn_code = code.split("-")
        except AttributeError:
            # Код может быть не заполнен
            continue

        map_code = torn_code[0]
        map_code = map_code.replace(",", ".")
        try:
            numeric_map_code = float(map_code)
        except ValueError:
            continue

        if numeric_map_code == 24:
            all_day_types.append(work_type.code)

    return all_day_types


def get_short_day_types():

    work_types = WorkType.objects.all()
    short_types = [WorkType.SHORT]
    for work_type in work_types:
        code = work_type.code
        try:
            torn_code = code.split("-")
        except AttributeError:
            # Код может быть не заполнен
            continue

        map_code = torn_code[0]
        map_code = map_code.replace(",", ".")
        try:
            numeric_map_code = float(map_code)
        except ValueError:
            continue

        if 1 <= numeric_map_code < 8:
            short_types.append(work_type.code)

    return short_types
